/*
 * COPYRIGHT:         See COPYING in the top level directory
 * PROJECT:           ReactOS Run-Time Library
 * PURPOSE:           Debug Routines
 * FILE:              lib/rtl/i386/debug.S
 * PROGRAMER:         Alex Ionescu (alex@relsoft.net)
 */

.intel_syntax noprefix

/* GLOBALS ****************************************************************/

.globl  _DbgBreakPoint@0
.globl  _DbgBreakPointWithStatus@4
.globl  _DbgUserBreakPoint@0
.globl  _DebugService@20

/* FUNCTIONS ***************************************************************/

_DbgBreakPoint@0:
_DbgUserBreakPoint@0:
    int 3
    ret
 
_DbgBreakPointWithStatus@4:
    mov eax, [esp+4]
    int 3
    ret 4

_DebugService@20:

    /* Setup the stack */
    push ebp
    mov ebp, esp

    /* Save the registers */
    push ecx
    push ebx
    push edi
    push edi
    push ebx

    /* Call the Interrupt */
    mov eax, [ebp+8]
    mov ecx, [ebp+12]
    mov edx, [ebp+16]
    mov ebx, [ebp+20]
    mov edi, [ebp+24]
    int 0x2D
    //int 3

    /* Restore registers */
    pop ebx
    pop edi
    pop edi
    pop ebx

    /* Return */
    leave
    ret 20

