RGENSTAT_BASE = $(TOOLS_BASE_)rgenstat
RGENSTAT_BASE_ = $(RGENSTAT_BASE)$(SEP)
RGENSTAT_INT = $(INTERMEDIATE_)$(RGENSTAT_BASE)
RGENSTAT_INT_ = $(RGENSTAT_INT)$(SEP)
RGENSTAT_OUT = $(OUTPUT_)$(RGENSTAT_BASE)
RGENSTAT_OUT_ = $(RGENSTAT_OUT)$(SEP)

$(RGENSTAT_INT): | $(TOOLS_INT)
	$(ECHO_MKDIR)
	${mkdir} $@

ifneq ($(INTERMEDIATE),$(OUTPUT))
$(RGENSTAT_OUT): | $(TOOLS_OUT)
	$(ECHO_MKDIR)
	${mkdir} $@
endif

RGENSTAT_TARGET = \
	$(EXEPREFIX)$(RGENSTAT_OUT_)rgenstat$(EXEPOSTFIX)

RGENSTAT_SOURCES = $(addprefix $(RGENSTAT_BASE_), \
	rgenstat.c \
	llmosrt.c \
	)

RGENSTAT_OBJECTS = \
	$(addprefix $(INTERMEDIATE_), $(RGENSTAT_SOURCES:.c=.o))

RGENSTAT_HOST_CFLAGS = -g -Werror -Wall

RGENSTAT_HOST_LFLAGS = -g

$(RGENSTAT_TARGET): $(RGENSTAT_OBJECTS) | $(RGENSTAT_OUT)
	$(ECHO_LD)
	${host_gcc} $(RGENSTAT_OBJECTS) $(RGENSTAT_HOST_LFLAGS) -o $@

$(RGENSTAT_INT_)rgenstat.o: $(RGENSTAT_BASE_)rgenstat.c | $(RGENSTAT_INT)
	$(ECHO_CC)
	${host_gcc} $(RGENSTAT_HOST_CFLAGS) -c $< -o $@

$(RGENSTAT_INT_)llmosrt.o: $(RGENSTAT_BASE_)llmosrt.c | $(RGENSTAT_INT)
	$(ECHO_CC)
	${host_gcc} $(RGENSTAT_HOST_CFLAGS) -c $< -o $@

.PHONY: rgenstat
rgenstat: $(RGENSTAT_TARGET)

.PHONY: rgenstat_clean
rgenstat_clean: $(RGENSTAT_TARGET)
	-@$(rm) $(RGENSTAT_TARGET) $(RGENSTAT_OBJECTS) 2>$(NUL)
clean: rgenstat_clean
